<?php

	if (!function_exists('array_remove')){
		function array_remove( &$array, $val ) {
			foreach ( $array as $i => $v ) {
				if ( $v == $val ) {
					array_splice( $array, $i, 1 );
					return $array;
				}
			}
			return $array;
		}
	}

	if (!function_exists('array_remove_all')){
		function array_remove_all( &$array, $val ) {
			$n = array();
			foreach ( $array as $i => $v ) {
				if ( $v != $val ) {
					array_push($n, $v);
				}
			}
			$array = $n;
			return $array;
		}
	}

	class FanplayrApi {
		function __construct() {
		}

		/* ---------------------------------------------------------------------------------
			actions
		*/
		public function applyCoupon()
		{
			// remember the code
			@$code = $_GET['code'];

			// ----------------------------------------
			// check for deputized coupon and replace
			@$deputies = $_SESSION['fanplayr_deputy_codes'];
			if (is_array($deputies) && array_key_exists($code, $deputies)) {
				$code = $deputies[$code];
			}

			// should be able to call it right?
			if (function_exists('wpsc_coupon_price'))
				wpsc_coupon_price($code);

			// redirect
			$lastUrl = $_SESSION['fanplayr_last_url'];
			$lastUrl = str_replace('fpshow=1', '', $lastUrl);

			if (empty($lastUrl))
				$lastUrl = '../';
			header('Location: ' . $lastUrl);

			exit(1);
		}

		public function deputizeCoupon()
		{
			@$actualCode = $_GET['a'];
			@$deputyCode = $_GET['d'];

			if ($actualCode && $deputyCode)
			{
				@$deputies = $_SESSION['fanplayr_deputy_codes'];
				if (!is_array($deputies))
					$deputies = array();

				$deputies[$deputyCode] = $actualCode;

				$_SESSION['fanplayr_deputy_codes'] = $deputies;
			}

			echo json_encode($deputies);
		}

	}

?>